#pragma once

#include <stddef.h>

#include "saohook/sao-dll.h"

#include "platform/config.h"
#include "gfxhook/config.h"
#include "amcus/config.h"
#include "board/config.h"

struct sao_hook_config {
    struct platform_config platform;
    struct aime_config aime;
    struct sao_dll_config dll;
    struct gfx_config gfx;
    struct amcus_config amcus;
    struct qr_config qr;
    struct bpreader_config reader;
    struct usio_config usio;
};

void sao_dll_config_load(
    struct sao_dll_config *cfg,
    const wchar_t *filename);

void qr_config_load(
    struct qr_config *cfg,
    const wchar_t *filename);

void sao_hook_config_load(
    struct sao_hook_config *cfg,
    const wchar_t *filename);

