$(BUILD_DIR_ZIP)/ferrum.zip:
	$(V)echo ... $@
	$(V)mkdir -p $(BUILD_DIR_ZIP)/ferrum
	$(V)cp $(BUILD_DIR_64)/subprojects/capnhook/inject/inject.exe \
		$(BUILD_DIR_64)/ferrumhook/ferrumhook.dll \
		$(DIST_DIR)/ferrum/bananatools.ini \
		$(DIST_DIR)/ferrum/start.bat \
    	$(BUILD_DIR_ZIP)/ferrum
	$(V)strip $(BUILD_DIR_ZIP)/ferrum/*.{exe,dll}
	$(V)cd $(BUILD_DIR_ZIP)/ferrum ; zip -r ../ferrum.zip *

$(BUILD_DIR_ZIP)/taiko.zip:
	$(V)echo ... $@
	$(V)mkdir -p $(BUILD_DIR_ZIP)/taiko
	$(V)cp $(BUILD_DIR_64)/subprojects/capnhook/inject/inject.exe \
		$(BUILD_DIR_64)/taikohook/taikohook.dll \
		$(DIST_DIR)/taiko/bananatools.ini \
		$(DIST_DIR)/taiko/start.bat \
    	$(BUILD_DIR_ZIP)/taiko
	$(V)strip $(BUILD_DIR_ZIP)/taiko/*.{exe,dll}
	$(V)cd $(BUILD_DIR_ZIP)/taiko ; zip -r ../taiko.zip *

$(BUILD_DIR_ZIP)/exvs2.zip:
	$(V)echo ... $@
	$(V)mkdir -p $(BUILD_DIR_ZIP)/exvs2
	$(V)cp $(BUILD_DIR_64)/subprojects/capnhook/inject/inject.exe \
		$(BUILD_DIR_64)/exvs2hook/exvs2hook.dll \
		$(DIST_DIR)/exvs2/bananatools.ini \
		$(DIST_DIR)/exvs2/start.bat \
    	$(BUILD_DIR_ZIP)/exvs2
	$(V)strip $(BUILD_DIR_ZIP)/exvs2/*.{exe,dll}
	$(V)cd $(BUILD_DIR_ZIP)/exvs2 ; zip -r ../exvs2.zip *

$(BUILD_DIR_ZIP)/sao.zip:
	$(V)echo ... $@
	$(V)mkdir -p $(BUILD_DIR_ZIP)/sao
	$(V)cp $(BUILD_DIR_64)/subprojects/capnhook/inject/inject.exe \
		$(BUILD_DIR_64)/saohook/saohook.dll \
		$(DIST_DIR)/sao/bananatools.ini \
		$(DIST_DIR)/sao/start.bat \
    	$(BUILD_DIR_ZIP)/sao
	$(V)strip $(BUILD_DIR_ZIP)/sao/*.{exe,dll}
	$(V)cd $(BUILD_DIR_ZIP)/sao ; zip -r ../sao.zip *

$(BUILD_DIR_ZIP)/mkac.zip:
	$(V)echo ... $@
	$(V)mkdir -p $(BUILD_DIR_ZIP)/mkac
	$(V)cp $(BUILD_DIR_32)/subprojects/capnhook/inject/inject.exe \
		$(BUILD_DIR_32)/mkachook/mkachook.dll \
		$(DIST_DIR)/mkac/bananatools.ini \
		$(DIST_DIR)/mkac/start.bat \
    	$(BUILD_DIR_ZIP)/mkac
	$(V)strip $(BUILD_DIR_ZIP)/mkac/*.{exe,dll}
	$(V)cd $(BUILD_DIR_ZIP)/mkac ; zip -r ../mkac.zip *

$(BUILD_DIR_ZIP)/doc.zip: \
		$(DOC_DIR)/ferrumhook.md \
		$(DOC_DIR)/taikohook.md \
		$(DOC_DIR)/exvs2hook.md \
		$(DOC_DIR)/saohook.md \
		| $(zipdir)/
	$(V)echo ... $@
	$(V)zip -r $@ $^

$(BUILD_DIR_ZIP)/bananatools.zip: \
		$(BUILD_DIR_ZIP)/ferrum.zip \
		$(BUILD_DIR_ZIP)/taiko.zip \
		$(BUILD_DIR_ZIP)/exvs2.zip \
		$(BUILD_DIR_ZIP)/sao.zip \
		$(BUILD_DIR_ZIP)/mkac.zip \
		$(BUILD_DIR_ZIP)/doc.zip \
		README.md \

	$(V)echo ... $@
	$(V)zip -j $@ $^
