#pragma once

#include <windows.h>

#include "mkacio/mkacio.h"

struct mkac_dll {
    uint16_t api_version;
    HRESULT (*jvs_init)(void);
    HRESULT (*gamepad_init)(void);
    HRESULT (*jvs_poll)(uint8_t *opbtn);
    HRESULT (*gamepad_poll)(uint16_t *gamebtn);
    void (*jvs_read_coin_counter)(uint16_t *coins);
};

struct mkac_dll_config {
    wchar_t path[MAX_PATH];
};

extern struct mkac_dll mkac_dll;

HRESULT mkac_dll_init(const struct mkac_dll_config *cfg, HINSTANCE self);
